﻿/*
 * Crée par SharpDevelop.
 * Utilisateur: bcristiano
 * Date: 09/03/2017
 * Heure: 10:17
 * 
 * Pour changer ce modèle utiliser Outils | Options | Codage | Editer les en-têtes standards.
 */
using System;
using System.Net;
using System.IO;
using System.Web;
using System.Collections.Generic;
using System.Text.RegularExpressions;
using System.Text;

namespace TestGCLogin
{
	class Program
	{
		/// <summary>
        /// Return web proxy (null if not defined)
        /// </summary>
        /// <returns>web proxy (null if not defined)</returns>
        public static WebProxy GetProxy()
        {
            WebProxy proxy = null;
            /*
            try
            {
				proxy = new WebProxy("domaineproxy:port", true);
                NetworkCredential credentials = new NetworkCredential("loginproxy", "passwordproxy");
                proxy.Credentials = credentials;
            }
            catch (Exception)
            {
                proxy = null;
            }*/
            return proxy;
        }
        
        /// <summary>
        /// Execute a regular expression
        /// </summary>
        /// <param name="input">input text</param>
        /// <param name="param">regular expression</param>
        /// <returns>result</returns>
        public static String DoRegex(String input, String param)
        {
            Match match = Regex.Match(input, param, RegexOptions.IgnoreCase);

            // Here we check the Match instance.
            if (match.Success)
            {
                // Finally, we get the Group value and display it.
                return match.Groups[1].Value;
            }
            else
                return "s";
        }
        
        /// <summary>
        /// Get a subset from a string, between 2 tags
        /// exemple:
        /// "toto is a weird guy"
        /// tag1 = "is a"
        /// tag2 = " guy"
        /// result = " weird"
        /// If the subset is not found, return ""
        /// </summary>
        /// <param name="tag1">beginning tag</param>
        /// <param name="tag2">end tag (if "", search will only be performed on tag1)</param>
        /// <param name="text">text to look into</param>
        /// <returns>If the subset is not found, return "", otherwise a matching subset</returns>
        public static String GetSnippetFromText(String tag1, String tag2, String text)
        {
            // Recherche la première occurence d'une chaine contenue entre tag1 et tag2 dans text
            String r = "";
            if (text != "")
            {

                int i1 = text.IndexOf(tag1);
                if (i1 != -1)
                {
                	int l1 = i1 + tag1.Length;
                    if (tag2 != "")
                    {
                        int i2 = text.IndexOf(tag2, l1);
                        if (i2 != -1)
                        {
                            r = text.Substring(l1, i2 - l1);
                        }
                    }
                    else
                    {
                        r = text.Substring(l1);
                    }
                }
            }
            return r;
        }
        
        /// <summary>
        /// Retrieve VIEWSTATE information from a Geocaching.com webpage
        /// </summary>
        /// <param name="response">webpage to parse</param>
        /// <param name="__VIEWSTATEFIELDCOUNT">retrieved __VIEWSTATEFIELDCOUNT value</param>
        /// <param name="__VIEWSTATE">retrieved __VIEWSTATE list</param>
        /// <param name="__VIEWSTATEGENERATOR">retrieved __VIEWSTATEGENERATOR value</param>
        public static void GetViewState(String response, ref String __VIEWSTATEFIELDCOUNT, ref String[] __VIEWSTATE, ref String __VIEWSTATEGENERATOR)
        {
            // __VIEWSTATEFIELDCOUNT" value="2" />
            // id="__VIEWSTATE" value="
            // id="__VIEWSTATE1" value="
            // <input type="hidden" name="__VIEWSTATEGENERATOR" id="__VIEWSTATEGENERATOR" value="25748CED" />
            
            __VIEWSTATEFIELDCOUNT = GetSnippetFromText("__VIEWSTATEFIELDCOUNT\" value=\"", "\"", response);
            if (__VIEWSTATEFIELDCOUNT == "")
            {
            	__VIEWSTATEFIELDCOUNT = "1";
            }
            int ivscount = Int32.Parse(__VIEWSTATEFIELDCOUNT);
            __VIEWSTATE = new string[ivscount];

            for (int i = 0; i < ivscount; i++)
            {
                if (i == 0)
                {
                    __VIEWSTATE[i] = GetSnippetFromText("id=\"__VIEWSTATE\" value=\"", "\"", response);
                }
                else
                {
                    __VIEWSTATE[i] = GetSnippetFromText("id=\"__VIEWSTATE" + i.ToString() + "\" value=\"", "\"", response);
                }
            }
            
            __VIEWSTATEGENERATOR = GetSnippetFromText("__VIEWSTATEGENERATOR\" value=\"", "\"", response);
        }
        
        /// <summary>
        /// Check geocaching account credentials
        /// </summary>
        /// <returns>authentication cookie</returns>
        public static CookieContainer CheckGCAccount(String username, String password)
        {
            try
            {
                // Notre container de cookies
                CookieContainer cookieJar = new CookieContainer();

                // Authentification sur GC.com
                // ***************************
                
                // *******
                // ETAPE 1
                // *******
                // Récupération des VIEWSTATE pour s'authentifier
                string VOID_URL = "https://www.geocaching.com/login/default.aspx";
                HttpWebResponse objResponse = null;
                HttpWebRequest objRequest = null;
            	objRequest = (HttpWebRequest)WebRequest.Create(VOID_URL);
            	objRequest.Proxy = GetProxy(); // Là encore, on peut virer le proxy si non utilisé (NULL)
            	objResponse = (HttpWebResponse)objRequest.GetResponse();
                
	            if (objResponse == null)
	            {
	            	Console.WriteLine("erreur d'accès à l'URL");
	            	return null;
	            }
	            
	            String post_response = "";
	            using (StreamReader responseStream = new StreamReader(objResponse.GetResponseStream()))
	            {
	                post_response = responseStream.ReadToEnd();
	                responseStream.Close();
	            }
	            Console.WriteLine("Contenu de la réponse dans input.html");
	            System.IO.StreamWriter file = new System.IO.StreamWriter("input.html", false);
	            file.WriteLine(post_response);
	            file.Close();
	            
	            // *******
                // ETAPE 2
                // *******
                String __VIEWSTATEFIELDCOUNT = "";
                String[] __VIEWSTATE = null;
                String __VIEWSTATEGENERATOR = "";
                GetViewState(post_response, ref __VIEWSTATEFIELDCOUNT, ref __VIEWSTATE, ref __VIEWSTATEGENERATOR);
                
                // *******
                // ETAPE 3
                // *******
                // Préparation des données du POST
                Dictionary<String, String> post_values = new Dictionary<String, String>();
                post_values.Add("__EVENTTARGET", "");
                post_values.Add("__EVENTARGUMENT", "");
                post_values.Add("ctl00$ContentBody$tbUsername", username);
                post_values.Add("ctl00$ContentBody$tbPassword", password);
                post_values.Add("ctl00$ContentBody$cbRememberMe", "on");
                post_values.Add("ctl00$ContentBody$btnSignIn", "Login");
				// Les viewstate
				post_values.Add("__VIEWSTATE", __VIEWSTATE[0]);
                if (__VIEWSTATE.Length > 1)
                {
                    for (int i = 1; i < __VIEWSTATE.Length; i++)
                    {
                        post_values.Add("__VIEWSTATE" + i.ToString(), __VIEWSTATE[i]);
                    }
                    post_values.Add("__VIEWSTATEFIELDCOUNT", __VIEWSTATE.Length.ToString());
                }
                if (__VIEWSTATEGENERATOR != "")
                	post_values.Add("__VIEWSTATEGENERATOR", __VIEWSTATEGENERATOR);
                
                // debug
                foreach(var pair in post_values)
                {
                	Console.WriteLine(pair.Key + " => " + pair.Value);
                }
                // Encodage des données du POST
                String post_string = "";
                foreach (KeyValuePair<String, String> post_value in post_values)
                {
                    post_string += post_value.Key + "=" + HttpUtility.UrlEncode(post_value.Value) + "&";
                }
                post_string = post_string.TrimEnd('&');
                
                // *******
                // ETAPE 4
                // *******
                // Création de la requête pour s'authentifier
                objRequest = (HttpWebRequest)WebRequest.Create(VOID_URL);
                objRequest.Method = "POST";
                //var data = Encoding.ASCII.GetBytes(post_string);
                //objRequest.ContentLength = data.Length;
                objRequest.ContentLength = post_string.Length;
                objRequest.ContentType = "application/x-www-form-urlencoded";
                //objRequest.Accept = "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8";
				//objRequest.UserAgent = "Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/54.0.2840.99 Safari/537.36";
                objRequest.Proxy = GetProxy(); // Créer votre proxy ici si besoin, sinon mettre NULL
                objRequest.CookieContainer = cookieJar;
                //objRequest.KeepAlive = false; 
                
                // on envoit les POST data dans un stream (écriture)
                StreamWriter myWriter = null;
                myWriter = new StreamWriter(objRequest.GetRequestStream());
                myWriter.Write(post_string);
                myWriter.Close();
				/*
				using (var stream = objRequest.GetRequestStream())
				{
				    stream.Write(data, 0, data.Length);
				}*/
				
				// *******
                // ETAPE 5
                // *******
                // lecture du stream de réponse et conversion en chaine
                objResponse = (HttpWebResponse)objRequest.GetResponse();
                using (StreamReader responseStream = new StreamReader(objResponse.GetResponseStream()))
                {
                    post_response = responseStream.ReadToEnd();
                    responseStream.Close();
                }
                
                // Pour le debug, interrogation du nombre de cookies retournés et trace de cette valeur
                // peut être supprimé
                int cookieCount = cookieJar.Count;
                String userloginfromgc = DoRegex(post_response, "ctl00_ContentBody_lbUsername\">.*<strong>(.*)</strong>");
                if (userloginfromgc.ToLower() == username.ToLower())
                {
                	Console.WriteLine("Authentification OK");
                    return cookieJar;
                }
                else
                {
                    Console.WriteLine("Authentification KO, login lu dans la réponse : ");
                    Console.WriteLine(userloginfromgc);
                    // Erreur?
                    String msg = GetSnippetFromText("FormErrorWidget","</div>", post_response);
                    msg = GetSnippetFromText("<li>","</li>", msg);
                    Console.WriteLine("Erreur : ");
                    Console.WriteLine(msg);
                    Console.WriteLine("Contenu de la réponse dans text.html");
		            file = new System.IO.StreamWriter("test.html", false);
		            file.WriteLine(post_response);
		            file.Close();
                    return null;
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Exception :");
                Console.WriteLine(ex.Message);
                return null;
            }
        }
        
		public static void Main(string[] args)
		{
			
			Console.WriteLine("Tentative d'authentification");
			CheckGCAccount("loginGC.com","mdpGC.com");
			
			Console.Write("Press any key to continue . . . ");
			Console.ReadKey(true);
		}
	}
}